// =========== Header ===========
// File:				APOP.cp
// Project:				APOP
// Written by:			Paul Guyot (pguyot@kallisys.net)
//
// Created on:			04/13/2002
// Internal version:	1
//
// Copyright:			 2002 by Paul Guyot.
// 						All rights reserved worldwide.
// License:				Kallisys Reflexive License
// ===========

// =========== Change History ===========
// 04/13/2002	v1	[PG]	Creation of the file
// ===========

#include <Newton.h>
#include <NSandDDKIncludes.h>
#include "md5.h"

// ------------------------------------------------------------------------	//
//	 ComputeMD5Digest
// ------------------------------------------------------------------------	//
// Cette mthode calcule un digest MD5  partir d'une chane NS (d'au plus 512 octets)
// Retourne le rsultat sous forme de chane NS (en notation hexa, minuscules)
// Utilise les fonctions dfinies dans md5.h (pour le moment?)
// La chane est convertie en ISO 8859-1 (enfin, on vire brutalement les octets de poids fort).

extern "C"
Ref
ComputeMD5Digest( RefArg inRcvr, RefArg inString )
{
	// Extraction et conversion de la chane
	UniChar* laChaine = GetCString( inString );
	unsigned char laChaineISO[512];
	
	unsigned int laLongueur = 0;
	for (; laLongueur < 512; laLongueur++)
	{
		unsigned char leChar = laChaineISO[laLongueur] = (unsigned char) laChaine[laLongueur];
		if (leChar == 0)
			break;
	}

	// Calcul du digest		
	MD5_CTX mdContext;

	MD5Init ( &mdContext );
	MD5Update ( &mdContext, laChaineISO, laLongueur );
	unsigned char digest[16];
	MD5Final ( digest, &mdContext );
	
	// Sortie du digest comme chane NS.
	char leResultat[33];
	int index_res;
	for (index_res = 0; index_res < 16; index_res++)
	{
		char leDigit = digest[index_res] >> 4;
		if (leDigit > 0x9)
		{
			leDigit += ('a' - 0xa);
		} else {
			leDigit += '0';
		}
		leResultat[2 * index_res] = leDigit;
		
		leDigit = digest[index_res] & 0x0F;
		if (leDigit > 0x9)
		{
			leDigit += ('a' - 0xa);
		} else {
			leDigit += '0';
		}
		leResultat[(2 * index_res) + 1] = leDigit;
	}
	leResultat[32] = 0;

	return MakeString( leResultat );
}

// ========================================================================= //
// Play Rogue, visit exotic locations, meet strange creatures and kill them. //
// ========================================================================= //